/* Tabela ENDECLIE: Endereo de cliente */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ENDECLIE */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Endereos de cliente
             utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_ENDECLIE
AFTER UPDATE OR INSERT OR DELETE
ON ENDECLIE FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(2000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_IDTPENDECLIE VARCHAR2(80);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DSREMOTEADDR := ' ';
   V_DSREMOTEHOST := ' ';
   V_DSSERVERRDM  := ' ';
   V_DSSERVMETHOD := ' ';
   V_DSREMOTEOPER := ' ';
   V_DESC         := ' ';
   V_ITPESQ       := ' ';
   V_NMOPERADOR   := ' ';
   V_IDTIPOOPER   := ' ';
   V_IDTPENDECLIE := ' ';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN
      IF :NEW.IDTPENDECLIE = 'P' THEN
         V_IDTPENDECLIE := 'Identificador do tipo de endereo: Principal ';
      ELSE
         IF :NEW.IDTPENDECLIE = 'C' THEN
            V_IDTPENDECLIE := 'Identificador do tipo de endereo: Cobrana ';
         ELSE
            IF :NEW.IDTPENDECLIE = 'E' THEN
               V_IDTPENDECLIE := 'Identificador do tipo de endereo: Exterior ';
            ELSE
               IF :NEW.IDTPENDECLIE = 'X' THEN
                  V_IDTPENDECLIE := 'Identificador do tipo de endereo: Exportao ';
               ELSE
                  IF :NEW.IDTPENDECLIE = 'T' THEN
                     V_IDTPENDECLIE := 'Identificador do tipo de endereo: Entrega ';
                  ELSE
                     IF :NEW.IDTPENDECLIE = 'O' THEN
                        V_IDTPENDECLIE := 'Identificador do tipo de endereo: Outros ';
                     ELSE
                        IF :NEW.IDTPENDECLIE = 'M' THEN
                           V_IDTPENDECLIE := 'Identificador do tipo de endereo: Comercial ';
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;

      V_DESC := 'Cdigo do cliente:  ' || :NEW.CDCLIENTE  ||'  '||
                'Endereo:  '          || :NEW.DSENDECLIE ||'  '||
                'Bairro:  '            || :NEW.NMBAIRCLIE ||'  '|| V_IDTPENDECLIE ||'  '||
                'Complemento:  '       || :NEW.DSCOMPENDCLI ||'  '||
                'CEP: '                || :NEW.NRCEPCLIE   ||'  '||
                'Cod.Pais:  '          || :NEW.CDPAIS      ||'  '||
                'Cod.Estado:  '        || :NEW.SGESTADO    ||'  '||
                'Cod.Municipio:  '     || :NEW.CDMUNICIPIO ||'  '||
                'EmailNFE: '           || :NEW.DSEMAILCLIENFE || '  '||
                '';

      V_IDTIPOOPER := '1';
      V_ITPESQ     := :NEW.CDCLIENTE;
   ELSE
      IF UPDATING THEN
         V_DESC := 'Cd.Cliente:  ' ||:NEW.CDCLIENTE ||'  ' ;

         IF (NVL (:OLD.DSENDECLIE,'X') <> NVL(:NEW.DSENDECLIE, 'X')) THEN
            V_DESC := V_DESC || 'Endereo:  ' || :NEW.DSENDECLIE ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NMBAIRCLIE,'X') <> NVL(:NEW.NMBAIRCLIE,'X')) THEN
            V_DESC := V_DESC || 'Bairro:  ' || :NEW.NMBAIRCLIE ||'  ' ;
         END IF;

         IF (:OLD.IDTPENDECLIE    <> :NEW.IDTPENDECLIE   ) THEN
            V_DESC := V_DESC || 'Tipo de Endereo:  ' || :NEW.IDTPENDECLIE  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.DSCOMPENDCLI,'X')   <> NVL(:NEW.DSCOMPENDCLI,'X')) THEN
            V_DESC := V_DESC || 'Complemento:  ' || :NEW.DSCOMPENDCLI  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRCEPCLIE,'X')  <> NVL(:NEW.NRCEPCLIE,'X')) THEN
            V_DESC := V_DESC || 'CEP:  ' || :NEW.NRCEPCLIE  ||'  ' ;
         END IF;

         IF (:OLD.CDPAIS    <> :NEW.CDPAIS   ) THEN
            V_DESC := V_DESC || 'Cod.Pais:  ' || :NEW.CDPAIS  ||'  ' ;
         END IF;

         IF (:OLD.SGESTADO    <> :NEW.SGESTADO   ) THEN
            V_DESC := V_DESC || 'Estado:  ' || :NEW.SGESTADO  ||'  ' ;
         END IF;

         IF (:OLD.CDMUNICIPIO <> :NEW.CDMUNICIPIO   ) THEN
            V_DESC := V_DESC || 'Cod.Municipio:  ' || :NEW.CDMUNICIPIO  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRTELECLIE,'X') <>  NVL(:NEW.NRTELECLIE,'X')) THEN
            V_DESC := V_DESC || 'Nr.Telefone:  ' || :NEW.NRTELECLIE  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRRAMALCLIE,'X') <> NVL(:NEW.NRRAMALCLIE,'X')) THEN
            V_DESC := V_DESC || 'Nr.Ramal:  ' || :NEW.NRRAMALCLIE  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRTELEXCLIE,'X') <> NVL(:NEW.NRTELEXCLIE, 'X')) THEN
            V_DESC := V_DESC || 'Nr.Tel.Exterior:  ' || :NEW.NRTELEXCLIE  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRFAXCLIE,'X')  <> NVL(:NEW.NRFAXCLIE,'X')) THEN
            V_DESC := V_DESC || 'Nr.Fax:  ' || :NEW.NRFAXCLIE  ||'  ' ;
         END IF;

         IF (NVL(:OLD.NMCONTCLIE,'X')  <> NVL(:NEW.NMCONTCLIE,'X')) THEN
            V_DESC := V_DESC || 'Nome da pessoa de contato no cliente:  ' || :NEW.NMCONTCLIE  ||'  ' ;
         END IF;

         IF (NVL(:OLD.DSEMAILCLIE,'X') <>  NVL(:NEW.DSEMAILCLIE,'X')) THEN
            V_DESC := V_DESC || 'E-MAIL:  ' || :NEW.DSEMAILCLIE  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRTELECLIE1,'X')<> NVL(:NEW.NRTELECLIE1,'X')) THEN
            V_DESC := V_DESC || 'Nr.Tel2:  ' || :NEW.NRTELECLIE1  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRRAMALCLIE1,'X') <> NVL(:NEW.NRRAMALCLIE1,'X')) THEN
            V_DESC := V_DESC || 'Nr.Ramal2:  ' || :NEW.NRRAMALCLIE1  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRCELULARCLI,'X') <> NVL(:NEW.NRCELULARCLI,'X')) THEN
            V_DESC := V_DESC || 'Nr.Celular:  ' || :NEW.NRCELULARCLI  ||'  ' ;
         END IF;

         IF (NVL(:OLD.NRTELRESICLI,'X')    <> NVL(:NEW.NRTELRESICLI,'X')) THEN
            V_DESC := V_DESC || 'Nmero do telefone residencial do cliente:  ' || :NEW.NRTELRESICLI  ||'  ' ;
         END IF;

         IF (NVL(:OLD.DSPTOREFECLI,'X')    <> NVL(:NEW.DSPTOREFECLI,'X')) THEN
            V_DESC := V_DESC || 'Ponto de referncia para o endereo do cliente:  ' || :NEW.DSPTOREFECLI  ||'  ' ;
         END IF;

         IF NVL(:OLD.DSEMAILCLIENFE, 'Z') <> NVL(:NEW.DSEMAILCLIENFE, 'Z') THEN
            V_DESC := V_DESC || 'Email NFE: ' || :NEW.DSEMAILCLIENFE || '  ';
         END IF;

         V_IDTIPOOPER := '2';
         V_ITPESQ     := :NEW.CDCLIENTE;

      ELSE
         IF DELETING THEN
            IF :NEW.IDTPENDECLIE = 'P' THEN
               V_IDTPENDECLIE :=  'Identificador do tipo de endereo: Principal ';
            ELSE
               IF :OLD.IDTPENDECLIE = 'C' THEN
                  V_IDTPENDECLIE := 'Identificador do tipo de endereo: Cobrana ';
               ELSE
                  IF :OLD.IDTPENDECLIE = 'E' THEN
                     V_IDTPENDECLIE := 'Identificador do tipo de endereo: Exterior ';
                  ELSE
                     IF :OLD.IDTPENDECLIE = 'X' THEN
                        V_IDTPENDECLIE := 'Identificador do tipo de endereo: Exportao ';
                     ELSE
                        IF :OLD.IDTPENDECLIE = 'T' THEN
                           V_IDTPENDECLIE := 'Identificador do tipo de endereo: Entrega ';
                        ELSE
                           IF :OLD.IDTPENDECLIE = 'O' THEN
                              V_IDTPENDECLIE := 'Identificador do tipo de endereo: Outros ';
                           ELSE
                              IF :OLD.IDTPENDECLIE = 'M' THEN
                                 V_IDTPENDECLIE := 'Identificador do tipo de endereo: Comercial ';
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;

            V_DESC := 'Cdigo do cliente:  ' || :OLD.CDCLIENTE  ||'  '||
                      'Endereo:  '          || :OLD.DSENDECLIE ||'  '||
                      'Bairro:  '            || :OLD.NMBAIRCLIE ||'  '|| V_IDTPENDECLIE ||'  '||
                      'Complemento:  '       || :OLD.DSCOMPENDCLI ||'  '||
                      'CEP:  :  '            || :OLD.NRCEPCLIE ||'  '||
                      'Cod.Pais:  '          || :OLD.CDPAIS||'  '||
                      'Cod.Estado:  '        || :OLD.SGESTADO ||'  '||
                      'Cod.Municipio:  '     || :OLD.CDMUNICIPIO ||'  '||
                      'EmailNFE : '          || :OLD.DSEMAILCLIENFE;

            V_IDTIPOOPER := '3';
            V_ITPESQ     := :OLD.CDCLIENTE;
         END IF;
      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_DESC := SUBSTR(V_DESC, 1, 300);

      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER)
                  VALUES   ('ENDECLIE', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                             V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                             V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                             V_DSSERVMETHOD,   V_DSREMOTEOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_ENDECLIE','4.09.013'); END;
/

